Rev.registerComponent('StoreInput', class extends React.Component {
  static get mixins() {
    return [ Rev.App.Mixins.StoreInputMixin, Backbone.Events ]
  }

  static get propTypes() {
    store: React.PropTypes.object.isRequired
    field: React.PropTypes.string.isRequired
    name: React.PropTypes.string
    baseName: React.PropTypes.string
  }

  constructor(props) {
    super(props)
    this.onFieldChange = this.onFieldChange.bind(this)
    this.isCheckbox = this.isCheckbox.bind(this)
    this.onBlur = this.onBlur.bind(this)
  }

  errors() {
    return this.props.store.errors[this.props.field]
  }

  render() {
    var t
    var form_params = {
      defaultValue: this.defaultValue(),
      value: this.value(),
      name: this.name()
    }

    if(this.props.type == 'select' || this.props.type == 'textarea') {
      t = this.props.type
    }

    if(this.isCheckbox()) {
      form_params['defaultChecked'] = this.value()
    }

    return <Rev.Components.Input
      key={this.props.field}
      dom={t}
      {...form_params}
      {...this.props}
      onChange={ this.onFieldChange }
      error={ this.errors() }
      onBlur={ this.onBlur }>
      { this.props.children }
    </Rev.Components.Input>
  }
})
