module RevelryData
  class Engine < ::Rails::Engine
    isolate_namespace RevelryData

    initializer 'revelry_data.configure_jr', before: 'react_rails.setup_vendor' do |app|
      JSONAPI.configure do |config|
        config.always_include_to_one_linkage_data = true
        config.always_include_to_many_linkage_data = true
      end
    end

    initializer 'revelry_data.blacklist_props', after: 'execjs_rails.setup_view_helpers' do |app|
      break unless defined?(ExecJS::Rails)
      config.execjs_rails.blacklisted_assigns += %w(request response)
    end
  end
end
